#
# spec file for package lucene
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define jarname lucene-core
Name:           lucene
Version:        6.6.0
Release:        62.3
Summary:        Text search engine
License:        Apache-2.0
Group:          Development/Libraries/Java
Url:            http://lucene.apache.org/
Source0:        http://www.apache.org/dist/lucene/java/%{version}/%{name}-%{version}-src.tgz
Source1:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-queryparser/%{version}/lucene-queryparser-%{version}.pom
Source2:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-join/%{version}/lucene-join-%{version}.pom
Source3:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-queries/%{version}/lucene-queries-%{version}.pom
Source4:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-classification/%{version}/lucene-classification-%{version}.pom
Source5:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-facet/%{version}/lucene-facet-%{version}.pom
Source6:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-codecs/%{version}/lucene-codecs-%{version}.pom
Source7:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-backward-codecs/%{version}/lucene-backward-codecs-%{version}.pom
Source8:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-grouping/%{version}/lucene-grouping-%{version}.pom
Source9:        http://repo1.maven.org/maven2/org/apache/lucene/lucene-highlighter/%{version}/lucene-highlighter-%{version}.pom
Source10:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-memory/%{version}/lucene-memory-%{version}.pom
Source11:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-misc/%{version}/lucene-misc-%{version}.pom
Source12:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-sandbox/%{version}/lucene-sandbox-%{version}.pom
Source13:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-spatial3d/%{version}/lucene-spatial3d-%{version}.pom
Source14:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-spatial/%{version}/lucene-spatial-%{version}.pom
Source15:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-analyzers-common/%{version}/lucene-analyzers-common-%{version}.pom
Source16:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-analyzers-smartcn/%{version}/lucene-analyzers-smartcn-%{version}.pom
Source17:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-analyzers-stempel/%{version}/lucene-analyzers-stempel-%{version}.pom
Source18:       http://repo1.maven.org/maven2/org/apache/lucene/lucene-core/%{version}/lucene-core-%{version}.pom
BuildRequires:  ant >= 1.6
BuildRequires:  ant-junit >= 1.6
BuildRequires:  antlr-java
BuildRequires:  apache-commons-beanutils
BuildRequires:  apache-commons-codec
BuildRequires:  apache-commons-collections
BuildRequires:  apache-commons-digester
BuildRequires:  apache-commons-logging
BuildRequires:  apache-ivy
BuildRequires:  fdupes
BuildRequires:  git
BuildRequires:  java-devel >= 1.8
BuildRequires:  javacc
BuildRequires:  javapackages-local
BuildRequires:  jtidy
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  regexp
BuildRequires:  zip
BuildArch:      noarch

%description
Apache Lucene is a full-text search engine written entirely in Java.
It offers fuzzy search based on edit (Levenshtein) distance,
incremental indexing, ranked searching, field-based searches and
multi-index searches.

%package queryparser
Summary:        Queryparser module for lucene
Group:          Development/Libraries/Java

%description queryparser
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "queryparser" module for lucene.

%files queryparser
%defattr(-,root,root)
%{_javadir}/lucene-queryparser-%{version}.jar

%package join
Summary:        Join module for lucene
Group:          Development/Libraries/Java

%description join
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "join" module for lucene.

%files join
%defattr(-,root,root)
%{_javadir}/lucene-join-%{version}.jar

%package queries
Summary:        Queries module for lucene
Group:          Development/Libraries/Java

%description queries
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "queries" module for lucene.

%files queries
%defattr(-,root,root)
%{_javadir}/lucene-queries-%{version}.jar

%package classification
Summary:        Classification module for lucene
Group:          Development/Libraries/Java

%description classification
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "classification" module for Lucene.

%files classification
%defattr(-,root,root)
%{_javadir}/lucene-classification-%{version}.jar

%package facet
Summary:        Facet module for lucene
Group:          Development/Libraries/Java

%description facet
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "facet" module for Lucene.

%files facet
%defattr(-,root,root)
%{_javadir}/lucene-facet-%{version}.jar

%package codecs
Summary:        Codecs module for lucene
Group:          Development/Libraries/Java

%description codecs
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "codecs" module for Lucene.

%files codecs
%defattr(-,root,root)
%{_javadir}/lucene-codecs-%{version}.jar

%package backward-codecs
Summary:        Backward-codecs module for lucene
Group:          Development/Libraries/Java

%description backward-codecs
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "backward-codecs" module for Lucene.

%files backward-codecs
%defattr(-,root,root)
%{_javadir}/lucene-backward-codecs-%{version}.jar

%package grouping
Summary:        Grouping module for lucene
Group:          Development/Libraries/Java

%description grouping
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "grouping" module for Lucene.

%files grouping
%defattr(-,root,root)
%{_javadir}/lucene-grouping-%{version}.jar

%package highlighter
Summary:        Highlighter module for lucene
Group:          Development/Libraries/Java

%description highlighter
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "highlighter" module for Lucene.

%files highlighter
%defattr(-,root,root)
%{_javadir}/lucene-highlighter-%{version}.jar

%package memory
Summary:        Memory module for lucene
Group:          Development/Libraries/Java

%description memory
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "memory" module for Lucene.

%files memory
%defattr(-,root,root)
%{_javadir}/lucene-memory-%{version}.jar

%package misc
Summary:        Misc module for lucene
Group:          Development/Libraries/Java

%description misc
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "misc" module for Lucene.

%files misc
%defattr(-,root,root)
%{_javadir}/lucene-misc-%{version}.jar

%package sandbox
Summary:        Sandbox module for lucene
Group:          Development/Libraries/Java

%description sandbox
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "sandbox" module for Lucene.

%files sandbox
%defattr(-,root,root)
%{_javadir}/lucene-sandbox-%{version}.jar

%package spatial3d
Summary:        Spatial3d module for lucene
Group:          Development/Libraries/Java

%description spatial3d
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "spatial3d" module for Lucene.

%files spatial3d
%defattr(-,root,root)
%{_javadir}/lucene-spatial3d-%{version}.jar

%package spatial
Summary:        Spatial module for lucene
Group:          Development/Libraries/Java

%description spatial
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "spatial" module for Lucene.

%files spatial
%defattr(-,root,root)
%{_javadir}/lucene-spatial-%{version}.jar

%package analyzers-common
Summary:        Analyzers-common module for lucene
Group:          Development/Libraries/Java

%description analyzers-common
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "analyzers-common" module for Lucene.

%files analyzers-common
%defattr(-,root,root)
%{_javadir}/lucene-analyzers-common-%{version}.jar

%package analyzers-smartcn
Summary:        Analyzers-smartcn module for lucene
Group:          Development/Libraries/Java

%description analyzers-smartcn
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "analyzers-smartcn" module for Lucene.

%files analyzers-smartcn
%defattr(-,root,root)
%{_javadir}/lucene-analyzers-smartcn-%{version}.jar

%package analyzers-stempel
Summary:        Analyzers-stempel module for lucene
Group:          Development/Libraries/Java

%description analyzers-stempel
Apache Lucene is a full-text search engine written entirely in Java.
This package provides the "analyzers-stempel" module for Lucene.

%files analyzers-stempel
%defattr(-,root,root)
%{_javadir}/lucene-analyzers-stempel-%{version}.jar

%prep
%setup -q

%build
export CLASSPATH=$(build-classpath commons-digester jtidy junit regexp)
export OPT_JAR_LIST=:
ant \
  -Djavacc.home=%{_bindir}/javacc \
  -Djavacc.jar=%{_javadir}/javacc.jar \
  -Djavacc.jar.dir=%{_javadir} \
  -Djavadoc.link=%{_javadocdir}/java \
  -Dversion=%{version} \
  -Divy.mode=local

# DOESN'T BUILD BECAUSE OF MISSING DEPS: replicator expressions spatial-extras analyzers-kuromoji analyzers-morfologik analyzers-phonetic
export modules="queryparser join queries classification facet codecs backward-codecs grouping highlighter memory misc sandbox spatial3d spatial"

for mod in $modules
do
  ant -f module-build.xml \
    -Djavacc.home=%{_bindir}/javacc \
    -Djavacc.jar=%{_javadir}/javacc.jar \
    -Djavacc.jar.dir=%{_javadir} \
    -Djavadoc.link=%{_javadocdir}/java \
    -Dversion=%{version} \
    -Divy.mode=local \
  jar-$mod
done

export modanalyzers="common smartcn stempel"
pushd analysis
ant \
  -Djavacc.home=%{_bindir}/javacc \
  -Djavacc.jar=%{_javadir}/javacc.jar \
  -Djavacc.jar.dir=%{_javadir} \
  -Djavadoc.link=%{_javadocdir}/java \
  -Dversion=%{version} \
  -Divy.mode=local \
$modanalyzers

%install
install -d -m 0755 %{buildroot}%{_javadir}

# maven pom dir
install -d -m 0755 %{buildroot}%{_mavenpomdir}/

install -p -m 0644 build/core/%{jarname}-%{version}.jar %{buildroot}%{_javadir}/%{jarname}-%{version}.jar
install -p -m 0644 %{_sourcedir}/lucene-core-%{version}.pom %{buildroot}%{_mavenpomdir}/JPP.%{name}-core-%{version}.pom
%add_maven_depmap JPP.%{name}-core-%{version}.pom lucene-core-%{version}.jar

export modules="queryparser join queries classification facet codecs backward-codecs grouping highlighter memory misc sandbox spatial3d spatial"
for mod in $modules
do
  install -p -m 0644 build/${mod}/lucene-$mod-%{version}.jar %{buildroot}%{_javadir}/lucene-$mod-%{version}.jar
  install -p -m 0644 %{_sourcedir}/lucene-${mod}-%{version}.pom %{buildroot}%{_mavenpomdir}/JPP.%{name}-${mod}-%{version}.pom
  %add_maven_depmap JPP.%{name}-${mod}-%{version}.pom lucene-${mod}-%{version}.jar
done

export modanalyzers="common smartcn stempel"
for mod in $modanalyzers
do
  install -p -m 0644 build/analysis/$mod/lucene-analyzers-$mod-%{version}.jar %{buildroot}%{_javadir}/lucene-analyzers-${mod}-%{version}.jar
  install -p -m 0644 %{_sourcedir}/lucene-analyzers-${mod}-%{version}.pom %{buildroot}%{_mavenpomdir}/JPP.%{name}-analyzers-${mod}-%{version}.pom
  %add_maven_depmap JPP.%{name}-analyzers-${mod}-%{version}.pom lucene-analyzers-${mod}-%{version}.jar
done

# javadoc DOES NOT BUILD BECAUSE OF MISSING MVN DEPS
# javadoc
#install -d -m 0755 %%{buildroot}%%{_javadocdir}/%%{name}
#cp -pr build/docs/api/* \
#  %%{buildroot}%%{_javadocdir}/%%{name}

%files
%defattr(-,root,root)
%doc CHANGES.txt LICENSE.txt README.txt
%{_javadir}/lucene-core-%{version}.jar
%{_mavenpomdir}/*
%{_datadir}/maven-metadata/%{name}.xml*

%changelog
* Tue Feb 12 2019 Fridrich Strba <fstrba@suse.com>
- Remove dependency on jline, because nothing in the build uses it
* Sat Dec 22 2018 Fridrich Strba <fstrba@suse.com>
- Require the different apache-commons-* packages instead of
  jakarta-commons-*
* Thu Nov  1 2018 Fridrich Strba <fstrba@suse.com>
- Do not require asm to build. Nothing depends on it
* Fri Sep 29 2017 fstrba@suse.com
- Minimum supported java is 1.8
* Mon Jul 10 2017 jengelh@inai.de
- Remove unused "%%package javadoc" declaration block.
- Trim filler words from descriptions.
  Say a thing about features.
* Thu Jun 29 2017 badshah400@gmail.com
- Update to version 6.6.0:
  + See https://lucene.apache.org/core/6_6_0/changes/Changes.html
    for a full list of changes.
- Drop patches that are no longer applicable or needed:
  + lucene-no-classpath-in-manifest.patch
  + lucene-no-get.patch
  + lucene-2.3.0-db-javadoc.patch
- Add BuildRequires: antlr-java, apache-commons-codec, apache-ivy,
  asm, fdupes, git
- Replace SOURCE0 by full source URL.
- Update to changed list of non-core modules:
  + Update source URL's for corresponding pom files.
  + Update %%%%install section to reflect changed list
  + Each module corresponds to a subpackage, named according to
    its jar file (except lucene which corresponds to the main
    jar file lucene-core-%%{version}.jar).
- Adapt file list to changes.
* Fri May 19 2017 dziolkowski@suse.com
- New build dependency: javapackages-local
* Wed Mar 18 2015 tchvatal@suse.com
- Fix build with new javapackages-tools
* Fri Jun 27 2014 tchvatal@suse.com
- Remove java-javdoc to build on sle11 again as the javadoc is
  also pulled in regardless.
* Tue Sep 10 2013 mvyskocil@suse.com
- use add_maven_depmap from javapackages-tools
* Mon Sep  9 2013 tchvatal@suse.com
- Move from jpackage-utils to javapackage-tools
* Tue Jun 26 2012 mvyskocil@suse.cz
- build require java-javadoc >= 1.6.0
* Thu Dec 10 2009 mvyskocil@suse.cz
- refreshed patches
  * lucene-2.3.0-db-javadoc.patch
  * lucene-no-get.patch
* Tue Sep 29 2009 mvyskocil@suse.cz
- fixed requires
* Tue May 26 2009 mvyskocil@suse.cz
- fixed bnc#507014: removed all jars from source tarball
* Tue May 12 2009 mvyskocil@suse.cz
- Initial SUSE packaging of lucene 2.4.1 (from jpp 5.0)
